#  Model job=[123] [npick=   ncont= ] > out.H
#  make models in one of three formats:
#	npick=			output picks(2,npick)
# 	         ncont= 	output signal(ncont)   (continuum)
# 	npick=   ncont= 	output signal(ncont)  (nearest spikes)
#	clip=1.
#	output also: o1,d1, n1,n2
#% 
integer n1, n2, esize, ncont, npick
from par:	integer n1=2, esize=4, npick=1, ncont=2
allocate:	real pair(2,npick), mm(ncont), neighbor(ncont)

subroutine doit(     pair,   npick,  mm,ncont,  neighbor       )
integer                      npick,     ncont
real                 pair(2, npick), mm(ncont), neighbor(ncont)
integer i1, it, iseed, job
real	time, arg, rand01,  o1,    d1, pi, value, clip
call null( pair,  2 * npick)
call null( mm,        ncont)
call null( neighbor,  ncont)
iseed= 1994;	pi= 3.14159
iseed= 19940;	pi= 3.14159
from par:	integer job=1
from par:	real	clip=1.
o1=0;
d1= 1./(ncont-1)
to history:	real o1, d1

do i1=1, npick {                   time = (.25 + rand01(iseed) * .50)
				   it   = 1.5 + (time-o1)/d1
	pair( 1, i1) =             time
	pair( 2, i1) = value( job, time) * clip
	neighbor(it) = pair( 2, i1)
	}

do i1=1, ncont {             time = o1 + d1*(i1-1)
	mm(i1) = value( job, time) * clip
	}

if(      getch('npick','i', npick)  > 0 &
         getch('ncont','i', ncont) == 0  ) {		# output picks
		to history: integer n1:2, n2:npick, n3:1
		call hclose()
		call srite( 'out', pair, 4*2*npick )
		}
else if( getch('npick','i', npick) == 0 &
         getch('ncont','i', ncont)  > 0  ) {		# output continuum
		to history: integer n1:ncont, n2:1, n3:1
		call srite( 'out', mm, 4*ncont )
		}

else if( getch('npick','i', npick) > 0 &
         getch('ncont','i', ncont) > 0  ) {	# output nearest neighbor picks.
		to history: integer n1:ncont, n2:1, n3:1
		call srite( 'out', neighbor, 4*ncont )
		}
return; end

real function value( job, time)
integer		     job
real                      time, pi, period, arg
pi= 3.14152965;		period = 15.
       if( job == 1) {
		arg = 2.*pi* 100. * time / period
		if( time > .25) 
			value =  sin ( arg) * exp( - 4.* (time-.25) )
		else
			value = 0
} else if( job == 2) {
		value  =  (sin( 200 * pi * time / period       ) +
		   	   sin( 200 * pi * time / period * 1.3 )  ) /2.
		
} else if( job == 3) {
		value  =  (sin( 200 * pi * time / 10.       ) +
		   	   sin( 200 * pi * time / 10. * 1.3 )  ) /2.
	}
return; end
