# Missif  - find MISSing Input values and Filter on the 1-axis to min power out.
#
#	<in.H	Missif [filtin=fin.H] [filtout=fout.H]  >out.H
#  input- 
#	in.H	data cube, exact zeros assumed missing values.
#	filtin  data cube of starting guess filters.
#			lag=1 is the constrained point of the filter.
#			if( filtin) then na=n1 and lag comes from fin.H
#			else	na=3 lag=1 	from command line
#	nmiss=n1	iteration count
#  output-
#	out.H	in.H with the holes filled in.
#	filtout 1-axis filters that minimize output power.  (nonlinear CG)
#	
# BUGS- Missing data values are taken to be those that are zero valued.
#	Nonlinear iteration is always unpredictable.
#	No way to average statistics over 2 and 3 axis.
# keyword missing data interpolation filter
#%
integer n1
from history:	integer n1
allocate:	real xx(n1), xfree(n1)

subroutine doit( n1, xx, xfree)
integer	esize, i1, n1, i2, n2, i3, n3, ia,na,lag, nmiss
real	xx(n1), xfree(n1), aa(2000)
character*1 filtname(80)
call putlin('Missing data fill in')
from history:	integer n2=1, n3=1
from history:	integer esize
from par:	integer  nmiss=n1
if( esize != 4) call erexit('bad esize')

if(getch('filtin','s',filtname) != 0 ) {
 	from aux:	filtin integer n1:na
 	from aux:	filtin integer lag
	}
else {
	from par:	integer na=3, lag=1
	do ia=1,na
		aa(ia) = 0.
	aa(lag) = 1.
	call putlin('filter in assumed spike')
	}
call auxputch('esize','i',4, 'filtout')
call auxputch(  'n1','i',na, 'filtout')
call auxputch(  'n2','i',n2, 'filtout')
call auxputch(  'n3','i',n3, 'filtout')
call auxputch( 'lag','i',lag,'filtout')
call putch('nmiss','i',nmiss)
call hclose()					#close header, no more putch
do i3=1,n3 {
	do i2=1,n2 {
		if(getch('filtin','s',filtname) != 0 ) {
			call sreed('filtin', aa, 4*na)
			}
		else {
			do i1=1,na
				aa(ia) = 0.
			aa(lag) = 1.
			}
		call sreed(  'in', xx,  esize * n1)

		do i1=1,n1
			if( xx(i1) == 0.)	xfree(i1)=1.
			else			xfree(i1)=0.
		call misif( na, lag, aa, n1,xx, xfree, nmiss)

		call srite('filtout', aa, 4*na)
		call srite( 'out',   xx, esize*n1)
		}
	}
return; end
